/* CC -pthread test.c */
#include<stdio.h>
#ifdef WIN32
#include<process.h>
#include<winsock2.h>

SOCKET	fd;									/*	fd							*/
#else
#include<pthread.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<arpa/inet.h>

#define	INVALID_SOCKET	-1
#define	SOCKET_ERROR	-1

int	fd;										/*	fd							*/
#endif

int
main(void);

int
waitReceive(void);

#ifdef WIN32
DWORD WINAPI
waitReceiveThread(LPVOID	pParam);
#else
void*
waitReceiveThread(void*	pParam);
#endif

int
waitReceive(void)
{
	fd_set	fds;
	char	buf[1024];
	int	recvSize;

	while(1)								/*	bZ[W[v			*/
	{
		FD_ZERO(&fds);						/*	fd_set				*/
		FD_SET(fd,&fds);					/*	fdݒ						*/
		select(fd + 1,&fds,NULL,NULL,NULL);	/*	f[^M҂				*/

		if(FD_ISSET(fd,&fds))				/*	Yfdǂݍ݃f[^H	*/
		{
											/*	f[^M					*/
			recvSize = recv(fd,buf,1024,0);

			printf("Received %d bytes\n",recvSize);

			if(recvSize == 0)				/*	CLOSEH					*/
			{
printf("check\n");
#ifdef WIN32
				closesocket(fd);			/*	CLOSE						*/
#else
				close(fd);
#endif
				break;						/*	[v𔲂				*/
			}
		}
	}

	return 0;
}

#ifdef WIN32
DWORD WINAPI
waitReceiveThread(LPVOID	pParam)
#else
void*
waitReceiveThread(void*	pParam)
#endif
{
	char	buf[1024];
	int	recvSize;

	while(1)
	{
											/*	f[^M҂				*/
		recvSize = recv(fd,buf,1024,0);

		printf("Received %d bytes\n",recvSize);

		if(recvSize == 0)					/*	CLOSEH					*/
		{
printf("check\n");
#ifdef WIN32
			closesocket(fd);				/*	CLOSE						*/
#else
			close(fd);
#endif
			break;							/*	[v𔲂				*/
		}
	}

#ifdef WIN32
	return 0;
#else
	return NULL;
#endif
}

int
main(void)
{
	struct sockaddr_in	addr;
	int	addrlen;
	char	buf[1024];
#ifdef WIN32
	HANDLE	hThread;
	DWORD	threadId;
	WORD	wVersionRequested = MAKEWORD(2,2);
	WSADATA	wsaData;

	WSAStartup(wVersionRequested,&wsaData);	/*	Winsock				*/
#else
	pthread_t	tid;
#endif

											/*	SOCKET쐬					*/
	if((fd = socket(AF_INET,SOCK_STREAM,IPPROTO_TCP)) == INVALID_SOCKET)
	{
		perror("socket");
		return -1;
	}

											/*	|[g̐ݒ				*/
	addr.sin_addr.s_addr = htonl(INADDR_ANY);
	addr.sin_family = AF_INET;
	addr.sin_port = htons(20319);
	
	addrlen = sizeof(addr);
											/*	BIND						*/
	if(bind(fd,(struct sockaddr*)&addr,addrlen) == SOCKET_ERROR)
	{
		perror("bind");
		return -1;
	}

											/*	LISTEN						*/
	if(listen(fd,0) == SOCKET_ERROR)
	{
		perror("listen");
		return -1;
	}

	printf("Listening\n");

											/*	ACCEPT						*/
	if((fd = accept(fd,(struct sockaddr*)&addr,&addrlen)) == INVALID_SOCKET)
	{
		perror("accept");
		return -1;
	}
	
	printf("Accepted\n");

											/*	zXg̃AhXA|[g	*/
/*	addr.sin_addr.s_addr = inet_addr("127.0.0.1");
	addr.sin_family = AF_INET;
	addr.sin_port = htons(20319);
	
	addrlen = sizeof(addr);*/

											/*	CONNECT						*/
/*	if(connect(fd,(struct sockaddr*)&addr,addrlen) == SOCKET_ERROR)
	{
		perror("connect");
		return -1;
	}

	printf("Connected\n");*/

	buf[0] = 91;
	buf[1] = 92;
	buf[2] = 93;
	buf[3] = 94;

	send(fd,buf,4,0);

	/*waitReceive();*/							/*	SELECTŎM҂			*/

#ifdef WIN32
											/*	MXbh			*/
	hThread = (HANDLE)_beginthreadex(NULL,0,waitReceiveThread,NULL,0,&threadId);

	WaitForSingleObject(hThread,INFINITE);	/*	MXbhI҂		*/
	CloseHandle(hThread);					/*	nhN[Y			*/
#else
											/*	MXbh			*/
	pthread_create(&tid,NULL,waitReceiveThread,NULL);
	pthread_join(tid,NULL);					/*	MXbhI҂		*/
#endif

#ifdef WIN32
	WSACleanup();							/*	WinsockI					*/
#endif

	return 0;
}
